--***************************************************************
--
-- pesiRuoteConfig
-- 
-- version 1.00 by mogli (biedens)
-- 2017/11/19 - version 1.0 (FS17)
--
--***************************************************************

pesiRuoteConfig = {}

--********************************
-- registerConfigurationType
--********************************
ConfigurationUtil.registerConfigurationType("pesiRuote", g_i18n:getText("pesiRuoteConfig"),  nil, nil, nil, ConfigurationUtil.SELECTOR_MULTIOPTION)

--********************************
-- prerequisitesPresent
--********************************
function pesiRuoteConfig.prerequisitesPresent(specializations) 
	return true
end 

--********************************
-- load
--********************************
function pesiRuoteConfig:load(savegame)
end

--********************************
-- postLoad
--********************************
function pesiRuoteConfig:postLoad(savegame)

  -- wheel weight setup
  local pesiRuoteId  = Utils.getNoNil(self.configurations["pesiRuote"], 1);
  local configKey = string.format("vehicle.pesiRuoteConfigurations.pesiRuoteConfiguration(%d)", pesiRuoteId-1);
  local key = configKey..".pesiRuotes";
	
	--print('pesiRuoteConfig:postLoad : key="'..tostring(key)..'"')
	
  if self.configurations["pesiRuote"] ~= nil and not hasXMLProperty(self.xmlFile, configKey.."#name") then
    print("Warning: Invalid pesiRuoteId '"..tostring(self.configurations["pesiRuote"]).."'. Using default wheel weight settings instead!");
  end;

  ObjectChangeUtil.updateObjectChanges(self.xmlFile, "vehicle.pesiRuoteConfigurations.pesiRuoteConfiguration", pesiRuoteId, self.components, self);

  self.pesiRuotes = {};
  local i = 0;
  while true do
    local pesiRuoteNameI  = string.format(".pesiRuote(%d)", i);
		local mass              = Vehicle.getConfigurationValue(self.xmlFile, key, pesiRuoteNameI, "#mass", getXMLFloat, nil)
		if mass == nil then
      break
    end
		local pesiRuote       = {}
		pesiRuote.mass        = mass
    pesiRuote.wheelIndex  = Vehicle.getConfigurationValue(self.xmlFile, key, pesiRuoteNameI, "#wheelIndex", getXMLInt,i)+1
		local wheel             = self.wheels[pesiRuote.wheelIndex]
		if wheel ~= nil then
			pesiRuote.wheelMass = wheel.mass
			wheel.mass            = wheel.mass + pesiRuote.mass
		end
		table.insert(self.pesiRuotes,pesiRuote)
    i = i+1;
  end
end

--********************************
-- delete
--********************************
function pesiRuoteConfig:delete()
end

--********************************
-- mouseEvent
--********************************
function pesiRuoteConfig:mouseEvent(posX, posY, isDown, isUp, button)
end

--********************************
-- keyEvent
--********************************
function pesiRuoteConfig:keyEvent(unicode, sym, modifier, isDown)
end

--********************************
-- update
--********************************
function pesiRuoteConfig:update(dt)
end

--********************************
-- updateTick
--********************************
function pesiRuoteConfig:updateTick(dt)
end

--********************************
-- draw
--********************************
function pesiRuoteConfig:draw()
end  

